var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { createElement as _createElement } from "react";
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import React, { useState } from 'react';
import { CloseOutlined } from '@react-devui/icons';
import { getClassName } from '@react-devui/utils';
import { DButton } from '../button';
import { usePrefixConfig, useTranslation } from '../root';
export function DHeader(props) {
    const { children, dClassNamePrefix, dActions, dCloseProps, dAriaLabelledby, onCloseClick, onClose } = props, restProps = __rest(props, ["children", "dClassNamePrefix", "dActions", "dCloseProps", "dAriaLabelledby", "onCloseClick", "onClose"]);
    //#region Context
    const dPrefix = usePrefixConfig();
    //#endregion
    const prefix = `${dPrefix}${dClassNamePrefix}`;
    const [t] = useTranslation();
    const [closeLoading, setCloseLoading] = useState(false);
    const closeProps = Object.assign(Object.assign({}, dCloseProps), { dLoading: (dCloseProps === null || dCloseProps === void 0 ? void 0 : dCloseProps.dLoading) || closeLoading, onClick: () => {
            const shouldClose = onCloseClick === null || onCloseClick === void 0 ? void 0 : onCloseClick();
            if (shouldClose instanceof Promise) {
                setCloseLoading(true);
                shouldClose.then((val) => {
                    setCloseLoading(false);
                    if (val !== false) {
                        onClose === null || onClose === void 0 ? void 0 : onClose();
                    }
                });
            }
            else if (shouldClose !== false) {
                onClose === null || onClose === void 0 ? void 0 : onClose();
            }
        } });
    return (_jsxs("div", Object.assign({}, restProps, { className: getClassName(restProps.className, `${prefix}__header`) }, { children: [_jsx("div", Object.assign({ id: dAriaLabelledby, className: `${prefix}__header-title` }, { children: children })), _jsx("div", Object.assign({ className: `${prefix}__header-actions` }, { children: React.Children.map(dActions, (action) => {
                    var _a, _b, _c;
                    return action === 'close' ? (_createElement(DButton, Object.assign({}, closeProps, { key: "$$close", "aria-label": (_a = closeProps['aria-label']) !== null && _a !== void 0 ? _a : t('Close'), dType: (_b = closeProps.dType) !== null && _b !== void 0 ? _b : 'text', dIcon: (_c = closeProps.dIcon) !== null && _c !== void 0 ? _c : _jsx(CloseOutlined, {}) }))) : (action);
                }) }))] })));
}
