import React from 'react';
export interface DTableThProps extends React.ThHTMLAttributes<HTMLTableCellElement> {
    dWidth?: number | string;
    dSort?: {
        options?: ('ascend' | 'descend' | null)[];
        active?: 'ascend' | 'descend' | null;
        onSort?: (order: 'ascend' | 'descend' | null) => void;
    };
    dActions?: React.ReactNode[];
    dFixed?: {
        top?: number | string;
        right?: number | string;
        bottom?: number | string;
        left?: number | string;
    };
    dAlign?: 'left' | 'right' | 'center';
    dEllipsis?: boolean;
}
export declare function DTableTh(props: DTableThProps): JSX.Element | null;
