import React from 'react';
import { useState } from 'react';
import { usePrefixConfig } from '../components/root';
export function useWave() {
    const dPrefix = usePrefixConfig();
    const [node, setNode] = useState(null);
    return [
        node,
        (color, animation) => setNode(React.createElement('div', {
            key: Math.random(),
            className: `${dPrefix}wave`,
            style: {
                [`--${dPrefix}wave-color`]: color,
                animation,
            },
            onAnimationEnd: (e) => {
                if (e.animationName === 'wave-fade-out') {
                    setNode(null);
                }
            },
        })),
    ];
}
