var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx } from "react/jsx-runtime";
import { isUndefined } from 'lodash';
import { useEffect, useRef } from 'react';
import { checkNodeExist, getClassName } from '@react-devui/utils';
import { registerComponentMate } from '../../utils';
import { DEmpty } from '../empty';
import { useComponentConfig, usePrefixConfig } from '../root';
const { COMPONENT_NAME } = registerComponentMate({ COMPONENT_NAME: 'DTable.Empty' });
export function DTableEmpty(props) {
    const _a = useComponentConfig(COMPONENT_NAME, props), { children, dColSpan } = _a, restProps = __rest(_a, ["children", "dColSpan"]);
    //#region Context
    const dPrefix = usePrefixConfig();
    //#endregion
    //#region Ref
    const tdRef = useRef(null);
    //#endregion
    useEffect(() => {
        var _a, _b;
        if (isUndefined(dColSpan) && tdRef.current) {
            let tableEl = tdRef.current.parentElement;
            while (tableEl && tableEl.tagName.toLowerCase() !== 'table') {
                tableEl = tableEl.parentElement;
            }
            if (tableEl) {
                let colSpan = 0;
                const cells = (_a = tableEl.rows.item(0)) === null || _a === void 0 ? void 0 : _a.cells;
                if (cells) {
                    for (let index = 0; index < cells.length; index++) {
                        colSpan += (_b = cells.item(index).colSpan) !== null && _b !== void 0 ? _b : 1;
                    }
                    tdRef.current.colSpan = colSpan;
                }
            }
        }
    });
    return (_jsx("tr", Object.assign({}, restProps, { className: getClassName(restProps.className, `${dPrefix}table__empty`) }, { children: _jsx("td", Object.assign({ ref: tdRef, colSpan: dColSpan }, { children: _jsx("div", Object.assign({ className: `${dPrefix}table__empty-content` }, { children: checkNodeExist(children) ? children : _jsx(DEmpty, {}) })) })) })));
}
